;;;; AJL - slepe prehladavanie, cast I, v1
;;; (C) MM, 2009

;;;; Zadanie: Prelievanie vody v nadobach    
;;;          
;;;  K dispozicii su dve nadoby, vacsia ma objem 4 l a mensia 3 l.      
;;;  Su na zaciatku prazdne, ulohou je dosiahnut, aby v malej
;;;  boli 2 litre, zatial co velka je prazdna.
;;;  Je mozne nadoby naplnit, vyprazdnit a prelievat vodu z jednej
;;;  nadoby do druhej.

;;;; Verzia 1 ******************************************************

(defun expanduj (stav)
  (cond
    ((equal stav '(0 . 0)) '((4 . 0) (0 . 3)))
    ((equal stav '(0 . 1)) '((0 . 0) (4 . 1) (0 . 3) (1 . 0)))
    ((equal stav '(0 . 2)) '((0 . 0) (4 . 2) (0 . 3) (2 . 0)))
    ((equal stav '(0 . 3)) '((0 . 0) (4 . 3) (3 . 0)))
    ((equal stav '(1 . 0)) '((0 . 0) (4 . 0) (1 . 3) (0 . 1)))
    ((equal stav '(1 . 1)) '((0 . 1) (1 . 0) (4 . 1) (1 . 3) (0 . 2) (2 . 0)))
    ((equal stav '(1 . 2)) '((0 . 2) (1 . 0) (4 . 2) (1 . 3) (0 . 3) (3 . 0)))
    ((equal stav '(1 . 3)) '((0 . 3) (1 . 0) (4 . 3) (4 . 0)))
    ((equal stav '(2 . 0)) '((0 . 0) (4 . 0) (2 . 3) (0 . 2)))
    ((equal stav '(2 . 1)) '((0 . 1) (2 . 0) (4 . 1) (2 . 3) (0 . 3) (3 . 0)))
    ((equal stav '(2 . 2)) '((0 . 2) (2 . 0) (4 . 2) (2 . 3) (1 . 3) (4 . 0)))
    ((equal stav '(2 . 3)) '((0 . 3) (2 . 0) (4 . 3) (4 . 1)))
    ((equal stav '(3 . 0)) '((0 . 0) (4 . 0) (3 . 3) (0 . 3)))
    ((equal stav '(3 . 1)) '((0 . 1) (3 . 0) (4 . 1) (3 . 3) (1 . 3) (4 . 0)))
    ((equal stav '(3 . 2)) '((0 . 2) (3 . 0) (4 . 2) (3 . 3) (4 . 1) (2 . 3)))
    ((equal stav '(3 . 3)) '((0 . 3) (3 . 0) (4 . 3) (4 . 2)))
    ((equal stav '(4 . 0)) '((0 . 0) (4 . 3) (1 . 3)))
    ((equal stav '(4 . 1)) '((0 . 1) (4 . 0) (4 . 3) (2 . 3)))
    ((equal stav '(4 . 2)) '((0 . 2) (4 . 0) (4 . 3) (3 . 3)))
    ((equal stav '(4 . 3)) '((0 . 3) (4 . 0)))))

(defparameter *open* '())
(defparameter *close* '())

(defun hladaj (ciel)
  (if (equal *open* '())
      nil
      (let* ((stav-na-expanziu (pop *open*))
	     (nove-stavy (expanduj stav-na-expanziu)))
	(push stav-na-expanziu *close*)
	(setf *open* (append *open* nove-stavy))
	(if (member ciel nove-stavy :test #'equal)
	    t
	    (hladaj ciel)))))

(defun ries (start ciel)
  (setf *open* (list start))
  (setf *close* '())
  (unless (equal start ciel) (hladaj ciel)))

;;;; Verzia 2 ******************************************************

(defun hladaj (ciel)
  (unless (equal *open* '())
    (let* ((stav-na-expanziu (pop *open*))
	   (nove-stavy (unless (member stav-na-expanziu *close* :test #'equal)
			 (expanduj stav-na-expanziu))))
      (push stav-na-expanziu *close*)
      (setf *open* (append *open* nove-stavy))
      (if (member ciel nove-stavy :test #'equal)
	  t
	  (hladaj ciel)))))

;;;; Verzia 3 ******************************************************

(defun informuj (stav-na-expanziu nove-stavy mod)
  (when (> mod 0)
    (format t "~%exp: ~a~%" stav-na-expanziu)
    (format t "  gen: ~{ ~a ~}" nove-stavy))
  (when (> mod 1)
    (format t "~%  open:  ~{~a~^ ~a~^ ~a~^ ~a ~#[ ~:;~%         ~]~}" *open*)
    (format t "~%  close: ~{~a~^ ~a~^ ~a~^ ~a ~#[ ~:;~%         ~]~}" *close*)))

(defun hladaj (ciel vypis)
  (unless (equal *open* '())
    (let* ((stav-na-expanziu (pop *open*))
	   (nove-stavy (unless (member stav-na-expanziu *close* :test #'equal)
			 (expanduj stav-na-expanziu))))
      (push stav-na-expanziu *close*)
      (setf *open* (append *open* nove-stavy))
      (informuj stav-na-expanziu nove-stavy vypis)
      (if (member ciel nove-stavy :test #'equal)
	  t
	  (hladaj ciel vypis)))))

(defun ries (start ciel &optional (vypis 1))
  (setf *open* (list start))
  (setf *close* '())
  (unless (equal start ciel) (hladaj ciel vypis)))

;;;; Verzia 4 ******************************************************

(defvar *mala-max* 3)
(defvar *velka-max* 4)

(defun obsah-malej (stav)
  (rest stav))

(defun obsah-velkej (stav)
  (first stav))

(defun op-vylej-velku ()
  #'(lambda (stav) (cons 0 (obsah-malej stav))))

(defun op-vylej-malu ()
  #'(lambda (stav) (cons (obsah-velkej stav) 0)))

(defun op-napln-velku ()
  #'(lambda (stav) (cons *velka-max* (obsah-malej stav))))

(defun op-napln-malu ()
  #'(lambda (stav) (cons (obsah-velkej stav) *mala-max*)))

(defun op-prelej-velku ()
  #'(lambda (stav)
      (if (< *mala-max* (+ (obsah-velkej stav) (obsah-malej stav)))
	  (cons (- (obsah-velkej stav)
		   (- *mala-max* (obsah-malej stav)))
		*mala-max*)
	  (cons 0 (+ (obsah-malej stav) (obsah-velkej stav))))))

(defun op-prelej-malu ()
  #'(lambda (stav)
      (if (< *velka-max* (+ (obsah-velkej stav) (obsah-malej stav)))
	  (cons *velka-max*
		(- (obsah-malej stav)
		   (- *velka-max* (obsah-velkej stav))))
	  (cons (+ (obsah-malej stav) (obsah-velkej stav)) 0))))

(defun find-operators (stav)
  (remove-if-not #'(lambda (x) x)
		 (list (when (< 0 (obsah-velkej stav))
			 (op-vylej-velku))
		       (when (< 0 (obsah-malej stav))
			 (op-vylej-malu))
		       (when (> *velka-max* (obsah-velkej stav))
			 (op-napln-velku))
		       (when (> *mala-max* (obsah-malej stav))
			 (op-napln-malu))
		       (when (and (< 0 (obsah-velkej stav)) 
				  (> *mala-max* (obsah-malej stav)))
			 (op-prelej-velku))
		       (when (and (< 0 (obsah-malej stav)) 
				  (> *velka-max* (obsah-velkej stav)))
			 (op-prelej-malu)))))

(defun expanduj (stav)
  (mapcar #'(lambda (operator) (funcall operator stav)) (find-operators stav)))


